//---------------------------------------------------------------------------
#include <vcl.h>
#include <mmsystem.hpp>
#pragma hdrstop
#define IM1 Image1->Canvas->Handle
#define IM2 Image2->Canvas->Handle
#define getkey(KY) GetKeyState(KY)&0x80
#include "poirec1.h"
#include "poiopt.h"
#include "poisize.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TFrmPoi *FrmPoi;
int POIBRD=30,SCX=320,SCY=240;
const TM=65536;
int l,ll,sp,x,y,xx,yy;short st,tx[TM],ty[TM],ts[TM];
char jo,mo;TRect r1;
AnsiString fi_ini;
//---------------------------------------------------------------------------
__fastcall TFrmPoi::TFrmPoi(TComponent* Owner)
        : TForm(Owner)
{
 fi_ini=ExtractFilePath(Application->ExeName)+"poirec.ini";
 li_ini=new TStringList();
 jo=0;JOYCAPS j;if(joyGetDevCaps(JOYSTICKID1,&j,sizeof(j))==JOYERR_NOERROR){jo=1;r1.Left= j.wXmin+(j.wXmax-j.wXmin)/3;r1.Right= j.wXmax-(j.wXmax-j.wXmin)/3;  r1.Top= j.wYmin+(j.wYmax-j.wYmin)/3;r1.Bottom= j.wYmax-(j.wYmax-j.wYmin)/3;}
// Image1->Width=SCX+POIBRD*2;Image1->Height=SCY+POIBRD*2;
 sp=8;ll=4;mo=0;LoadIni();RecInit();
}
//---------------------------------------------------------------------------
void __fastcall TFrmPoi::LoadIni(void){
 if(FileExists(fi_ini)){
  try{
  li_ini->LoadFromFile(fi_ini);
   SCX=StrToInt(INI("SCX"));
   SCY=StrToInt(INI("SCY"));
   POIBRD=StrToInt(INI("POIBRD"));
   ll=StrToInt(INI("ll"));
   sp=StrToInt(INI("sp"));
  }catch(...){Application->MessageBox("iniװ","װ",MB_OK|MB_ICONERROR);}}
 else{// Default INI
}}

void __fastcall TFrmPoi::SaveIni(void){
 INI("SCX")=SCX;
 INI("SCY")=SCY;
 INI("POIBRD")=POIBRD;
 INI("ll")=ll;
 INI("sp")=sp;
 li_ini->Sort();
 li_ini->SaveToFile(fi_ini);}

void __fastcall TFrmPoi::RecInit(void){
 Image1->Picture->Bitmap=NULL;
 Image1->Width=SCX+POIBRD*2;Image1->Height=SCY+POIBRD*2;
 PatBlt(IM1,0,0,SCX+POIBRD*2,SCY+POIBRD*2,BLACKNESS);
 Image1->Canvas->Pen->Color=clGray;
 Image1->Canvas->Brush->Color=clBlack;
 Image1->Canvas->Rectangle(POIBRD-1,POIBRD-1,SCX+POIBRD,SCY+POIBRD);
 ClientWidth=SCX+POIBRD*2;ClientHeight=SCY+POIBRD*2;

 st=0;l=0;x=0;y=0;xx=0;yy=0;
 Image1->Refresh();}

void __fastcall TFrmPoi::Start1Click(TObject *Sender)
{RecInit();}
//---------------------------------------------------------------------------
void __fastcall TFrmPoi::RecPoint(int sx,int sy){
 if(++l==ll||mo!=0){l=0;
  if(st==TM)return;
  BitBlt(IM1,sx-4,sy-4,7,7,IM2,0,0,SRCCOPY);
  Image1->Refresh();
  tx[st]=sx;ty[st]=sy;++st;
  Caption="poirec - "+IntToStr(st)+" ("+IntToStr(x)+":"+IntToStr(y)+")";}
}

void __fastcall TFrmPoi::Image1MouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
 if(Button==mbLeft){l=0;x=X;y=Y;RecPoint(X,Y);
  Caption="poirec - ("+IntToStr(x)+":"+IntToStr(y)+")";
  }
}
//---------------------------------------------------------------------------
void __fastcall TFrmPoi::Image1MouseMove(TObject *Sender, TShiftState Shift,
      int X, int Y)
{
 if(Shift.Contains(ssLeft)){x=X;y=Y;RecPoint(X,Y);}
}
//---------------------------------------------------------------------------
void __fastcall TFrmPoi::Exit1Click(TObject *Sender)
{Close();}
//---------------------------------------------------------------------------
void __fastcall TFrmPoi::SaveClick(TObject *Sender)
{
 if(!SaveDialog1->Execute())return;
 short *p,*m,i;int han;
 m=new short[st*2+1];
 p=m;*(p++)=st;
 for(i=0;i<st;i++){*(p++)=tx[i];}
 for(i=0;i<st;i++){*(p++)=ty[i];}

 if((han=FileCreate(SaveDialog1->FileName))==-1){return;}
 FileWrite(han,m,2*(st*2+1));
 FileClose(han);
}
//----------------------------------------------------------

void __fastcall TFrmPoi::Timer1Timer(TObject *Sender)
{
 if(mo!=1&&mo!=2)return;
int k1=0,k2=0,k3=0,k4=0,ks=0,kz=0,kx=0,sx,sy;
JOYINFO j1;if(jo==1){
if(joyGetPos(JOYSTICKID1,&j1)==JOYERR_NOERROR){
 if(j1.wXpos<r1.Left)k4=1;if(j1.wXpos>r1.Right)k2=1;
 if(j1.wYpos<r1.Top)k1=1;if(j1.wYpos>r1.Bottom)k3=1;
 if(j1.wButtons==JOY_BUTTON1){kz=1;ks=1;}}}
if(getkey(VK_UP))k1=1;  if(getkey(VK_RIGHT))k2=1;
if(getkey(VK_DOWN))k3=1;if(getkey(VK_LEFT))k4=1;
if(getkey(VK_SPACE))ks=1; if(getkey(VK_ESCAPE))Close();
if(getkey('Z')){kz=1;ks=1;}if(getkey('X')){kx=1;ks=1;}
sx=x;sy=y;
 switch(mo){
  case 1:if(k1&&yy>-sp)yy-=2;if(k3&&yy<sp)yy+=2;
   if(k4&&xx>-sp)xx-=2;if(k2&&xx<sp)xx+=2;
   if(xx>0)--xx;if(xx<0)++xx;
   if(yy>0)--yy;if(yy<0)++yy;
   x+=xx;y+=yy;break;
  case 2:if(k1)y-=sp;if(k3)y+=sp;
   if(k4)x-=sp;if(k2)x+=sp;
   break;}
 if(sx!=x||sy!=y)RecPoint(x,y);
}
//---------------------------------------------------------------------------
void __fastcall TFrmPoi::Mouse1Click(TObject *Sender)
{
 mo=((TMenuItem*)Sender)->Tag;
 ((TMenuItem*)Sender)->Checked=true;
}
//---------------------------------------------------------------------------
void __fastcall TFrmPoi::Option1Click(TObject *Sender)
{
 FrmOpt->EdtL->Text=IntToStr(ll);
 FrmOpt->EdtSp->Text=IntToStr(sp);
 if(FrmOpt->ShowModal()==mrOk){l=0;
  ll=StrToInt(FrmOpt->EdtL->Text);
  sp=StrToInt(FrmOpt->EdtSp->Text);}
}
//---------------------------------------------------------------------------

void __fastcall TFrmPoi::Size1Click(TObject *Sender)
{
 FrmSize->EdtX->Text=IntToStr(SCX);
 FrmSize->EdtY->Text=IntToStr(SCY);
 FrmSize->EdtBrd->Text=IntToStr(POIBRD);
 if(FrmSize->ShowModal()==mrOk){l=0;
  SCX=StrToInt(FrmSize->EdtX->Text);
  SCY=StrToInt(FrmSize->EdtY->Text);
  POIBRD=StrToInt(FrmSize->EdtBrd->Text);RecInit();}
}
//---------------------------------------------------------------------------


void __fastcall TFrmPoi::FormClose(TObject *Sender, TCloseAction &Action)
{
SaveIni();        
}
//---------------------------------------------------------------------------

